
*************************************************************************
*** Title:    Scroll Text + Raster                                    ***
*** Version:  1.00                                                    ***
*************************************************************************

PLANESIZE_CRED	=	80*240
COPPERSIZE	=	4000
FONTSIZE	=	15360

CHIPMEM		=	$060000
COPPERLIST_CRED	=	CHIPMEM
PLANEADRX_CRED	=	COPPERLIST_CRED+COPPERSIZE
FONTADR		=	PLANEADRX_CRED+PLANESIZE_CRED

Start:		bsr	system_push
		lea.l	interrupt3(pc),a0
		move.l	a0,$6c
		bsr	scrolltext
		bsr	system_pop
		rts

interrupt3:	bsr	bars
		move.w	#$0020,$dff09c
		rte

*******************************************************
******* scroll text main code *************************
*******************************************************

scrolltext:	bsr	makeview
		move.w	#$c020,$dff09a
		bsr	buildtxtlist
		movea.l	#FONTADR,a0
		lea.l	superfont(pc),a1
		move.w	#15360/4-1,d0
110$:		move.l	(a1)+,(a0)+
		dbra	d0,110$
		lea.l	textptlist(pc),a5	;ptblock
		move.l	(a5)+,d6		;number of lines
1$:		btst	#6,$bfe001
		beq.s	8$
		bsr	scrollup
		subq.l	#1,d6
		beq.s	8$
		bra.s	1$
8$:		bsr	closeview2
		rts

calctextline:	move.l	(a5)+,a2
		movem.l	d0/d6-d7/a5,-(sp)
		bsr	pssftype
		movem.l	(sp)+,d0/d6-d7/a5
		rts

waitblt:	macro
		btst	#14,$dff002
		bne.s	*-8
		endm

scrollup:	move.w	#231*64+40,d7
		move.w	#30,d0
		move.w	#$8640,$dff096

1$:		bsr	wait_line_w1
		waitblt
		move.w	#$03aa,$dff040
		move.w	#$0000,$dff042
		move.w	#$ffff,$dff044
		move.w	#$ffff,$dff046
		move.l	#PLANEADRX_CRED+80,$dff048
		move.l	#PLANEADRX_CRED,$dff054
		move.w	#$0000,$dff060
		move.w	#$0000,$dff066
		move.w	d7,$dff058
		waitblt

		sub.w	#64,d7
		dbra	d0,1$

		bsr	calctextline
		move.w	#10,d0

7$:		movem.l	d0/d6/a5,-(sp)
		bsr	blt_text_line
		movem.l	(sp)+,d0/d6/a5

		bsr	wait_line_w1
		waitblt
		move.w	#$03aa,$dff040
		move.w	#$0000,$dff042
		move.w	#$ffff,$dff044
		move.w	#$ffff,$dff046
		move.l	#PLANEADRX_CRED+80,$dff048
		move.l	#PLANEADRX_CRED,$dff054
		move.w	#$0000,$dff060
		move.w	#$0000,$dff066
		move.w	d7,$dff058
		waitblt

		sub.w	#64,d7
		dbra	d0,7$
		rts

wait_line_w1:	move.l	d0,-(sp)
1$:		move.l	$dff004,d0
		andi.l	#$0001f000,d0
		cmp.l	#$00008000,d0
		bne.s	1$
		move.l	(sp)+,d0
		rts

*******************************************************
******* end of scroll text main code ******************
*******************************************************


*******************************************************
******* scroll text ***********************************
*******************************************************

buildtxtlist:	movem.l	d0-d7/a0-a6,-(sp)
		lea.l	tekstblock(pc),a0	;tekstblock
		lea.l	textptlist(pc),a2	;ptblock
		lea.l	4(a2),a1		;ptlist
		clr.l	d7			;stringcounter
1$:		tst.b	(a0)			;more strings?
		beq	9$			;no->end
		add.l	#1,d7			;count strings
		move.l	a0,(a1)+		;store pointer in list
		clr.l	d6			;length counter
2$:		tst.b	(a0)
		beq	3$
		add.l	#1,d6
		adda.l	#1,a0
		bra	2$
3$:		adda.l	#1,a0
		bra	1$
9$:		move.l	d7,(a2)
		movem.l	(sp)+,d0-d7/a0-a6
		rts

textptlist:	dc.l	0	;length
		ds.l	400	;max number of text lines

tekstblock:
		dc.b	2,"Scroll Text with Raster Bars",0
		dc.b	1,"                  ",0
		dc.b	2,"Text can be printet in 3 modes:",0
		dc.b	1,"This line is left adjust.",0
		dc.b	3,"This line is right adjust.",0
		dc.b	2,"This line is center adjust",0
		dc.b	1,"                  ",0
		dc.b	2,"The program is writen for",0
		dc.b	2,"the DevPac Assembler.",0
		dc.b	1,"                  ",0
		dc.b	1,"Special fonts:",0
		dc.b	3,"       ",0
		dc.b	1,"                  ",0
		dc.b	1,"                  ",0
		dc.b	2,"Scroll Text with Raster Bars",0
		dc.b	1,"                  ",0
		dc.b	2,"Text can be printet in 3 modes:",0
		dc.b	1,"This line is left adjust.",0
		dc.b	3,"This line is right adjust.",0
		dc.b	2,"This line is center adjust",0
		dc.b	1,"                  ",0
		dc.b	2,"The program is writen for",0
		dc.b	2,"the DevPac Assembler.",0
		dc.b	1,"                  ",0
		dc.b	1,"Special fonts:",0
		dc.b	3,"       ",0
		dc.b	1,"                  ",0
		dc.b	2,"Scroll Text with Raster Bars",0
		dc.b	1,"                  ",0
		dc.b	2,"Text can be printet in 3 modes:",0
		dc.b	1,"This line is left adjust.",0
		dc.b	3,"This line is right adjust.",0
		dc.b	2,"This line is center adjust",0
		dc.b	1,"                  ",0
		dc.b	2,"The program is writen for",0
		dc.b	2,"the DevPac Assembler.",0
		dc.b	1,"                  ",0
		dc.b	1,"Special fonts:",0
		dc.b	3,"       ",0
		dc.b	1,"                  ",0
		dc.b	2,"Scroll Text with Raster Bars",0
		dc.b	1,"                  ",0
		dc.b	2,"Text can be printet in 3 modes:",0
		dc.b	1,"This line is left adjust.",0
		dc.b	3,"This line is right adjust.",0
		dc.b	2,"This line is center adjust",0
		dc.b	1,"                  ",0
		dc.b	2,"The program is writen for",0
		dc.b	2,"the DevPac Assembler.",0
		dc.b	1,"                  ",0
		dc.b	1,"Special fonts:",0
		dc.b	3,"       ",0
		dc.b	1,"                  ",0
		dc.b	1,"                  ",0
		dc.b	1,"                  ",0
		dc.b	0,0,0,0,0,0,0,0
		even

*******************************************************
******* end of scroll text ****************************
*******************************************************

*******************************************************
******* setup display *********************************
*******************************************************

COPPERVIEW_E:	macro
		move.l	#$008e2c81,(a0)+
		move.l	#$0090f4c1,(a0)+
		move.l	#$0092003c,(a0)+
		move.l	#$009400d4,(a0)+
		move.l	#$01009200,(a0)+
		move.l	#$01020000,(a0)+
		move.l	#$01040024,(a0)+
		move.l	#$01080000,(a0)+
		move.l	#$010a0000,(a0)+
		endm

makeview:	bsr	sletplanx
		movea.l	#COPPERLIST_CRED,a0
		COPPERVIEW_E
		lea.l	plane_ptrx(pc),a1
		bsr	copper_planes


		move.w	#$2b07,d0
		move.w	d0,(a0)+
		move.w	#$ff01,(a0)+
		move.w	#210,d1
		lea.l	copptr(pc),a1
		move.l	a0,(a1)
1$:		move.w	#$0180,(a0)+
		move.w	#0,(a0)+
		add.w	#$0100,d0
		move.w	d0,(a0)+
		move.w	#$fffe,(a0)+
		dbf	d1,1$
		bsr	copper_end
		move.l	#COPPERLIST_CRED,$dff080
		clr.w	$dff088


		movea.l	#$dff180,a0
;display colors
		move.w	#$000,(a0)+	;c0
		move.w	#$fff,(a0)+	;c1

		move.w	#$8380,$dff096
		rts

closeview2:	move.w	#$0180,$dff096
		rts

sletplanx:	move.l	#(PLANESIZE_CRED)/4-1,d0
		movea.l	#PLANEADRX_CRED,a0
1$:		clr.l	(a0)+
		dbra	d0,1$
		rts

plane_ptrx:
		dc.l	PLANEADRX_CRED
		dc.l	0
		dc.l	0
		dc.l	0
		dc.l	0
		dc.l	0
		dc.l	0
		dc.l	0

copper_planes:	movem.l d1/d3-d4/a1,-(sp)
		moveq.l	#$5,d4
		move.w	#$0e0,d3
1$:		move.l	(a1)+,d1
		beq.s	2$
		move.w	d3,(a0)+
		addq.w	#2,d3
		swap	d1
		move.w	d1,(a0)+
		move.w	d3,(a0)+
		addq.w	#2,d3
		swap	d1
		move.w	d1,(a0)+
2$:		dbf	d4,1$
		movem.l	(sp)+,d1/d3-d4/a1
		rts

copper_end:	move.l	#$fffffffe,(a0)+
		rts

*******************************************************
******* end of setup display **************************
*******************************************************

*******************************************************
******* text printing *********************************
*******************************************************

pssftype:	lea.l	blt_memory(pc),a6
		clr.l	(a6)
		lea.l	8(a6),a5
		move.l	a5,4(a6)
		lea.l	atosfontcontab(pc),a3	;convert table
		lea.l	propfontdata(pc),a4	;convert table
		move.l	#0,d1
		clr.l	d3
		clr.l	d4
		clr.l	d0
		move.b	(a2)+,d4		;pos mode
		cmp.b	#3,d4
		beq	5$
		cmp.b	#2,d4
		beq	6$
		bra	1$
5$:		bsr	pssflength
		move.l	#640,d6
		sub.l	d5,d6
		add.l	d6,d1
		bra	1$
6$:		bsr	pssflength
		move.l	#640,d6
		sub.l	d5,d6
		lsr.l	#1,d6
		add.l	d6,d1
		bra	1$
1$:		tst.b	(a2)
		beq	2$
		move.b	(a2)+,d3
		move.b	0(a3,d3.w),d0
		move.w	d0,(a5)+
		move.w	d1,(a5)+
		addq.l	#1,(a6)
		move.b	0(a4,d0.w),d0
		add.l	d0,d1
		add.l	#1,d1
		bra	1$
2$:		rts

blt_text_line:	clr.l	d0
		clr.l	d1
		move.w	#4,d2
		lea.l	FONTADR,a0			;font
		move.l	#PLANEADRX_CRED+200*80,a1	;plane pt
		lea.l	blt_memory(pc),a6
		move.l	4(a6),a5
1$:		tst.l	(a6)
		beq.s	9$
		move.w	(a5)+,d0
		move.w	(a5)+,d1
		subq.l	#1,(a6)
		bsr	bltsuperfont
		dbra	d2,1$
9$:		move.l	a5,4(a6)
		rts

pssflength:	movem.l	d0/d3/a2,-(sp)
		clr.l	d5
1$:		tst.b	(a2)
		beq	2$
		move.b	(a2)+,d3
		move.b	0(a3,d3.w),d0
		move.b	0(a4,d0.w),d0
		add.l	#1,d5
		add.l	d0,d5
		bra	1$
2$:		movem.l	(sp)+,d0/d3/a2
		rts

bltsuperfont:	movem.l	d0-d1/a0-a1,-(sp)
		lsl.l	#7,d0
		adda.l	d0,a0
		move.w	d1,d0
		andi.w	#$f,d0
		lsl.w	#8,d0
		lsl.w	#4,d0
		or.w	#$0bfa,d0
		lsr.l	#4,d1
		lsl.l	#1,d1
		adda.l	d1,a1
		move.w	#$8640,$dff096
1$:		btst	#14,$dff002
		bne.s	1$
		move.w	d0,$dff040		;bltcon0
		move.w	#$0000,$dff042		;bltcon1
		move.l	#$ffff0000,$dff044	;bltfwm/lwm
		move.l	a1,$dff048		;bltcpt
		move.l	a0,$dff050		;bltapt
		move.l	a1,$dff054		;bltdpt
		move.w	#74,$dff060		;bltcmod
		move.w	#-2,$dff064		;bltamod
		move.w	#74,$dff066		;bltdmod
		move.w	#$07c3,$dff058		;bltsize
		movem.l	(sp)+,d0-d1/a0-a1
		rts

blt_memory:	ds.l	160

*******************************************************
******* end of text printing **************************
*******************************************************

*******************************************************
******* text font data ********************************
*******************************************************

propfontdata:
	dc.b	20,19,18,21,16,16,18,20,7,13,20,15,25,20,21,18,21,19,15,19
	dc.b	19,20,29,19,21,17,26,24,20,0,0,0,0,0,0,0,0,0,0,0
	dc.b	13,15,13,14,13,10,15,14,5,8,14,5,24,14,14,15,14,10,11,10
	dc.b	14,13,20,13,13,12,18,16,13,19,19,0,0,0,0,0,0,0,0,0
	dc.b	13,13,14,14,13,14,14,14,14,14,6,6,0,0,0,0,0,0,0,20
	dc.b	7,20,24,13,28,12,19,14,10,10,7,23,8,19,19,13,7,12,6,6

atosfontcontab:
	dc.b	0,0,0,0,0,0,0,0,0,0		;0-9
	dc.b	0,0,0,0,0,0,0,0,0,0		;10-19
	dc.b	0,0,0,0,0,0,0,0,0,0		;20-29
	dc.b	0,0,99,100,0,0,0,0,0,110	;30-39
	dc.b	108,109,0,0,118,114,119,0,89,80	;40-49
	dc.b	81,82,83,84,85,86,87,88,90,91	;50-59
	dc.b	0,0,0,116,0,0,1,2,3,4		;60-69
	dc.b	5,6,7,8,9,10,11,12,13,14	;70-79
	dc.b	15,16,17,18,19,20,21,22,23,24	;80-89
	dc.b	25,0,0,0,0,0,0,40,41,42		;90-99
	dc.b	43,44,45,46,47,48,49,50,51,52	;100-109
	dc.b	53,54,55,56,57,58,59,60,61,62	;110-119
	dc.b	63,64,65,0,0,0,0,0,0,0		;120-129
	dc.b	0,0,0,0,0,0,0,0,0,0		;130-139
	dc.b	0,0,0,0,0,0,0,0,0,0		;140-149
	dc.b	0,0,0,0,0,0,0,0,0,0		;150-159
	dc.b	0,0,0,0,0,0,0,0,0,69		;160-169
	dc.b	0,0,0,0,70,0,0,0,0,0		;170-179
	dc.b	0,0,0,0,0,0,0,0,0,0		;180-189
	dc.b	0,0,0,0,0,0,0,28,26,0		;190-199
	dc.b	0,0,0,0,0,0,0,0,0,0		;200-209
	dc.b	0,0,0,0,0,0,27,0,0,0		;210-219
	dc.b	0,0,0,0,0,0,0,0,0,68		;220-229
	dc.b	66,0,0,0,0,0,0,0,0,0		;230-239
	dc.b	0,0,0,0,0,0,0,0,67,0		;240-249
	dc.b	0,0,0,0,0,0,0,0,0,0		;250-259

superfont:

*** [0|0]
	dc.l	$0,$0,$f80000,$1fc0000
	dc.l	$1fc0000,$1fc0000,$3be0000,$39e0000
	dc.l	$39e0000,$79f0000,$79f0000,$71f0000
	dc.l	$f0f8000,$f0f8000,$f0f8000,$1e07c000
	dc.l	$1fffc000,$1fffc000,$3fffe000,$3c03e000
	dc.l	$3c03e000,$7803f000,$7801f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|1]
	dc.l	$0,$0,$1ffe0000,$1fff0000
	dc.l	$1fff8000,$1f0fc000,$1f07c000,$1f07c000
	dc.l	$1f07c000,$1f07c000,$1f0f8000,$1fff0000
	dc.l	$1fff8000,$1f07c000,$1f03e000,$1f03e000
	dc.l	$1f03e000,$1f03e000,$1f03e000,$1f07e000
	dc.l	$1fffc000,$1fff8000,$1ffe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|2]
	dc.l	$0,$0,$ff0000,$3ffc000
	dc.l	$7ffc000,$fc1c000,$1f000000,$1f000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$1f000000,$1f004000,$fc1c000
	dc.l	$7ffc000,$3ff8000,$fe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|3]
	dc.l	$0,$0,$1ffe0000,$1fff8000
	dc.l	$1fffc000,$1f07e000,$1f01f000,$1f01f000
	dc.l	$1f00f800,$1f00f800,$1f00f800,$1f00f800
	dc.l	$1f00f800,$1f00f800,$1f00f800,$1f00f800
	dc.l	$1f00f800,$1f01f000,$1f01f000,$1f07e000
	dc.l	$1fffe000,$1fff8000,$1ffe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|4]
	dc.l	$0,$0,$1fff0000,$1fff0000
	dc.l	$1fff0000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1ffe0000
	dc.l	$1ffe0000,$1ffe0000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1fff8000,$1fff8000,$1fff8000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|5]
	dc.l	$0,$0,$1fff0000,$1fff0000
	dc.l	$1fff0000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1ffc0000
	dc.l	$1ffc0000,$1ffc0000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|6]
	dc.l	$0,$0,$ff8000,$3ffe000
	dc.l	$7ffe000,$fc0e000,$1f000000,$1f000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e0fe000,$3e0fe000,$3e0fe000,$3e01e000
	dc.l	$3e01e000,$1f01e000,$1f01e000,$fc1e000
	dc.l	$7ffe000,$3ffe000,$ff8000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|7]
	dc.l	$0,$0,$1f01f000,$1f01f000
	dc.l	$1f01f000,$1f01f000,$1f01f000,$1f01f000
	dc.l	$1f01f000,$1f01f000,$1f01f000,$1ffff000
	dc.l	$1ffff000,$1ffff000,$1f01f000,$1f01f000
	dc.l	$1f01f000,$1f01f000,$1f01f000,$1f01f000
	dc.l	$1f01f000,$1f01f000,$1f01f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|8]
	dc.l	$0,$0,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$3e000000
	dc.l	$3e000000,$3e000000,$3e000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|9]
	dc.l	$0,$0,$1f00000,$1f00000
	dc.l	$1f00000,$1f00000,$1f00000,$1f00000
	dc.l	$1f00000,$1f00000,$1f00000,$1f00000
	dc.l	$1f00000,$1f00000,$1f00000,$1f00000
	dc.l	$1f00000,$1f00000,$1f00000,$61f00000
	dc.l	$7ff00000,$7fe00000,$1f800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|10]
	dc.l	$0,$0,$1e01f000,$1e03e000
	dc.l	$1e07c000,$1e0f8000,$1e1f0000,$1e3e0000
	dc.l	$1e7c0000,$1efc0000,$1ff80000,$1ff80000
	dc.l	$1ffc0000,$1ffe0000,$1fbe0000,$1f1f0000
	dc.l	$1e0f8000,$1e0f8000,$1e07c000,$1e03e000
	dc.l	$1e01e000,$1e01f000,$1e00f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|11]
	dc.l	$0,$0,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1ffe0000,$1ffe0000,$1ffe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|12]
	dc.l	$0,$0,$1f801f80,$1fc03f80
	dc.l	$1fc03f80,$1fc03f80,$1ec03780,$1ee07780
	dc.l	$1ee07780,$1ee07780,$1ef0f780,$1e70e780
	dc.l	$1e70e780,$1e79e780,$1e79e780,$1e39c780
	dc.l	$1e39c780,$1e39c780,$1e198780,$1e1f8780
	dc.l	$1e1f8780,$1e0f0780,$1e0f0780,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|13]
	dc.l	$0,$0,$1f80f000,$1fc0f000
	dc.l	$1fc0f000,$1fc0f000,$1ee0f000,$1ee0f000
	dc.l	$1ef0f000,$1e70f000,$1e78f000,$1e78f000
	dc.l	$1e38f000,$1e3cf000,$1e3cf000,$1e1cf000
	dc.l	$1e1ef000,$1e0ef000,$1e0ef000,$1e07f000
	dc.l	$1e07f000,$1e07f000,$1e03f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|14]
	dc.l	$0,$0,$fe0000,$3ff8000
	dc.l	$7c7c000,$f01e000,$1f01f000,$1e00f000
	dc.l	$3e00f800,$3e00f800,$3e00f800,$3e00f800
	dc.l	$3e00f800,$3e00f800,$3e00f800,$3e00f800
	dc.l	$3e00f800,$1f01f000,$1f01f000,$f01e000
	dc.l	$fc7e000,$3ff8000,$fe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|15]
	dc.l	$0,$0,$1ffc0000,$1fff0000
	dc.l	$1fff8000,$1f0f8000,$1f07c000,$1f07c000
	dc.l	$1f07c000,$1f07c000,$1f07c000,$1f0f8000
	dc.l	$1fff8000,$1fff0000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$1f000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|16]
	dc.l	$0,$0,$fe0000,$3ff8000
	dc.l	$7c7c000,$f01e000,$1f01f000,$1e00f000
	dc.l	$3e00f800,$3e00f800,$3e00f800,$3e00f800
	dc.l	$3e00f800,$3e00f800,$3e00f800,$3e00f800
	dc.l	$3e00f800,$1e3cf000,$1f3ff000,$f3fe000
	dc.l	$fdfe000,$3ff8000,$ffc000,$7c000
	dc.l	$7e000,$3e000,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|17]
	dc.l	$0,$0,$1ffc0000,$1fff0000
	dc.l	$1fff8000,$1f0fc000,$1f07c000,$1f07c000
	dc.l	$1f07c000,$1f07c000,$1f0f8000,$1fff0000
	dc.l	$1ffe0000,$1f3c0000,$1f3e0000,$1f1e0000
	dc.l	$1f1f0000,$1f1f0000,$1f0f8000,$1f0f8000
	dc.l	$1f07c000,$1f07c000,$1f03e000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|18]
	dc.l	$0,$0,$7f00000,$ffc0000
	dc.l	$1ffc0000,$3c1c0000,$3c000000,$3c000000
	dc.l	$3c000000,$3f000000,$1fe00000,$1ff80000
	dc.l	$ffc0000,$7fc0000,$fe0000,$3e0000
	dc.l	$1e0000,$1e0000,$601e0000,$783c0000
	dc.l	$7ffc0000,$3ff80000,$7e00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [0|19]
	dc.l	$0,$0,$7fffe000,$7fffe000
	dc.l	$7fffe000,$f80000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|0]
	dc.l	$0,$0,$1f01e000,$1f01e000
	dc.l	$1f01e000,$1f01e000,$1f01e000,$1f01e000
	dc.l	$1f01e000,$1f01e000,$1f01e000,$1f01e000
	dc.l	$1f01e000,$1f01e000,$1f01e000,$1f01e000
	dc.l	$1f01e000,$1f01e000,$1f03e000,$f83c000
	dc.l	$fffc000,$3ff8000,$fe0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|1]
	dc.l	$0,$0,$7c00f000,$7c00f000
	dc.l	$7e00f000,$3e01e000,$3e01e000,$3f01e000
	dc.l	$1f03c000,$1f03c000,$1f83c000,$f878000
	dc.l	$f878000,$f878000,$7cf0000,$7cf0000
	dc.l	$7cf0000,$3ce0000,$3ee0000,$1fc0000
	dc.l	$1fc0000,$1fc0000,$f80000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|2]
	dc.l	$0,$0,$701fc038,$781fe078
	dc.l	$781fe078,$781de078,$7c3ce078,$3c3cf0f0
	dc.l	$3c3cf0f0,$3c3cf0f0,$3c3870f0,$1e7878e0
	dc.l	$1e7879e0,$1e7879e0,$1e7079e0,$e7039c0
	dc.l	$e7039c0,$e7039c0,$ef03dc0,$fe01fc0
	dc.l	$7e01f80,$7e01f80,$7c01f80,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|3]
	dc.l	$0,$0,$3e03e000,$3f07c000
	dc.l	$1f078000,$1f8f8000,$f9f0000,$7de0000
	dc.l	$3fe0000,$3fc0000,$1f80000,$f80000
	dc.l	$f80000,$1fc0000,$3fc0000,$3de0000
	dc.l	$79f0000,$f8f8000,$f0f8000,$1e07c000
	dc.l	$3e07e000,$7c03e000,$7c03f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|4]
	dc.l	$0,$0,$7c00f000,$7e01f000
	dc.l	$3e01e000,$3f03e000,$1f83c000,$f878000
	dc.l	$fcf8000,$7cf0000,$7ef0000,$3fe0000
	dc.l	$1fc0000,$1fc0000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$f80000
	dc.l	$f80000,$f80000,$f80000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|5]
	dc.l	$0,$0,$3fff8000,$3fff8000
	dc.l	$3fff8000,$1f0000,$3f0000,$3e0000
	dc.l	$7e0000,$7c0000,$f80000,$1f80000
	dc.l	$1f00000,$3f00000,$3e00000,$7c00000
	dc.l	$fc00000,$f800000,$1f800000,$1f000000
	dc.l	$3fff8000,$3fff8000,$3fff8000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|6]
	dc.l	$0,$0,$7fffc0,$7fffc0
	dc.l	$3f03c0,$3f00c0,$3f00c0,$770000
	dc.l	$770000,$770000,$f70700,$c70700
	dc.l	$c7ff00,$1c70700,$1ff0700,$1ff0700
	dc.l	$1870000,$3870000,$3070060,$3070060
	dc.l	$f0700e0,$7f9fffe0,$7f9fffe0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|7]
	dc.l	$0,$700,$fe0e00,$3ff9c00
	dc.l	$7c7f800,$f01f000,$1f01f000,$1e00f000
	dc.l	$3e01f800,$3e03f800,$3e07f800,$3e0ef800
	dc.l	$3e1cf800,$3e38f800,$3e70f800,$3ee0f800
	dc.l	$3fc0f800,$1f81f000,$1f81f000,$f01e000
	dc.l	$fc7e000,$1fff8000,$38fe0000,$70000000
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|8]
	dc.l	$0,$f00000,$1980000,$1980000
	dc.l	$f00000,$f80000,$1fc0000,$1fc0000
	dc.l	$1fc0000,$3be0000,$39e0000,$79f0000
	dc.l	$79f0000,$71f0000,$f0f8000,$f0f8000
	dc.l	$1e07c000,$1fffc000,$1fffc000,$3fffe000
	dc.l	$3c03e000,$7803f000,$7801f000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|9]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|10]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|11]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|12]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|13]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|14]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|15]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|16]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|17]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|18]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [1|19]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|0]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$fe00000,$3ff00000,$30780000
	dc.l	$20780000,$780000,$1f80000,$1ff80000
	dc.l	$3c780000,$78780000,$78780000,$78780000
	dc.l	$78f80000,$3ff80000,$f780000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|1]
	dc.l	$0,$0,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3df00000,$3ff80000,$3c3c0000
	dc.l	$3c1c0000,$3c1e0000,$3c1e0000,$3c1e0000
	dc.l	$3c1e0000,$3c1e0000,$3c1e0000,$3c1c0000
	dc.l	$3c3c0000,$3ff80000,$3de00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|2]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$7e00000,$1ff80000,$3c180000
	dc.l	$38000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$38080000
	dc.l	$3c380000,$1ff80000,$7e00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|3]
	dc.l	$0,$0,$3c0000,$3c0000
	dc.l	$3c0000,$3c0000,$3c0000,$3c0000
	dc.l	$3c0000,$7bc0000,$1ffc0000,$3c3c0000
	dc.l	$383c0000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$383c0000
	dc.l	$3c3c0000,$1ffc0000,$7bc0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|4]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$7c00000,$1ff00000,$3c700000
	dc.l	$78780000,$78380000,$78380000,$7ff80000
	dc.l	$7ff80000,$78000000,$78000000,$38000000
	dc.l	$3c180000,$1ff80000,$7e00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|5]
	dc.l	$0,$0,$7c00000,$fc00000
	dc.l	$1e400000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$ff000000,$ff000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|6]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$f8e0000,$3ffe0000,$38e00000
	dc.l	$78f00000,$78f00000,$78f00000,$78f00000
	dc.l	$38e00000,$3fe00000,$2f800000,$30000000
	dc.l	$3fe00000,$3ff80000,$3ff80000,$3ffc0000
	dc.l	$701c0000,$701c0000,$701c0000,$38380000
	dc.l	$3ff80000,$fe00000,$0
	dc.l	0
*** [2|7]
	dc.l	$0,$0,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3cf00000,$3df80000,$3e3c0000
	dc.l	$3e3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|8]
	dc.l	$0,$f8000000,$f8000000,$f8000000
	dc.l	$f8000000,$f8000000,$0,$0
	dc.l	$0,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|9]
	dc.l	$0,$1f000000,$1f000000,$1f000000
	dc.l	$1f000000,$1f000000,$0,$0
	dc.l	$0,$f000000,$f000000,$f000000
	dc.l	$f000000,$f000000,$f000000,$f000000
	dc.l	$f000000,$f000000,$f000000,$f000000
	dc.l	$f000000,$f000000,$f000000,$f000000
	dc.l	$f000000,$f000000,$df000000,$fe000000
	dc.l	$7c000000,$0,$0
	dc.l	0
*** [2|10]
	dc.l	$0,$0,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3cfc0000,$3cf80000,$3df00000
	dc.l	$3fe00000,$3fc00000,$3fc00000,$3fc00000
	dc.l	$3fe00000,$3fe00000,$3df00000,$3cf80000
	dc.l	$3cf80000,$3c7c0000,$3c3c0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|11]
	dc.l	$0,$0,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$78000000
	dc.l	$78000000,$78000000,$78000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|12]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3cf87c00,$3dfcfe00,$3f1f8f00
	dc.l	$3e1f0f00,$3c1e0f00,$3c1e0f00,$3c1e0f00
	dc.l	$3c1e0f00,$3c1e0f00,$3c1e0f00,$3c1e0f00
	dc.l	$3c1e0f00,$3c1e0f00,$3c1e0f00,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|13]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3cf00000,$3df80000,$3e3c0000
	dc.l	$3e3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|14]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$7c00000,$1ff00000,$3c780000
	dc.l	$38380000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$38380000
	dc.l	$3c780000,$1ff00000,$fe00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|15]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3df00000,$3ff80000,$3c3c0000
	dc.l	$3c3c0000,$3c1e0000,$3c1e0000,$3c1e0000
	dc.l	$3c1e0000,$3c1e0000,$3c1e0000,$3c3c0000
	dc.l	$3c3c0000,$3ff80000,$3de00000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$0,$0
	dc.l	0
*** [2|16]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$7bc0000,$1ffc0000,$3c3c0000
	dc.l	$3c3c0000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$3c3c0000
	dc.l	$3c3c0000,$1ffc0000,$7bc0000,$3c0000
	dc.l	$3c0000,$3c0000,$3c0000,$3c0000
	dc.l	$3c0000,$0,$0
	dc.l	0
*** [2|17]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3cc00000,$3dc00000,$3fc00000
	dc.l	$3f000000,$3e000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|18]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$1f800000,$3fc00000,$70c00000
	dc.l	$70000000,$70000000,$7f000000,$3f800000
	dc.l	$1fc00000,$7e00000,$e00000,$40e00000
	dc.l	$70e00000,$7fc00000,$1f800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [2|19]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$7fc00000,$7fc00000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e400000,$1fc00000,$f000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|0]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c3c0000,$3c3c0000,$3c3c0000,$3c3c0000
	dc.l	$3c7c0000,$1ffc0000,$f3c0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|1]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$78380000,$78780000,$78780000
	dc.l	$78780000,$3cf00000,$3cf00000,$3cf00000
	dc.l	$3cf00000,$1ce00000,$1ee00000,$1fe00000
	dc.l	$fc00000,$fc00000,$fc00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|2]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$70f07000,$78f8f000,$78f8f000
	dc.l	$78f8f000,$39b8e000,$3dbde000,$3dbde000
	dc.l	$3dbde000,$3d9de000,$1d1dc000,$1f1fc000
	dc.l	$1f1fc000,$1f1fc000,$e0f8000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|3]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$78780000,$7cf00000,$3df00000
	dc.l	$1fe00000,$fc00000,$fc00000,$7800000
	dc.l	$7800000,$fc00000,$1fe00000,$3ce00000
	dc.l	$3cf00000,$78780000,$78780000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|4]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$78380000,$78780000,$7c780000
	dc.l	$3c780000,$3c700000,$1cf00000,$1ef00000
	dc.l	$1ee00000,$ee00000,$ee00000,$7c00000
	dc.l	$7c00000,$7c00000,$3c00000,$3800000
	dc.l	$3800000,$7800000,$7f000000,$7e000000
	dc.l	$7c000000,$0,$0
	dc.l	0
*** [3|5]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$7ff00000,$7ff00000,$1f00000
	dc.l	$1e00000,$3c00000,$7c00000,$7800000
	dc.l	$f000000,$1f000000,$1e000000,$3c000000
	dc.l	$7c000000,$7ff00000,$7ff00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|6]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$1f9f0000,$39fb8000,$38f1c000
	dc.l	$38f1c000,$f1c000,$7ffc000,$1ff00000
	dc.l	$38f00000,$70f00000,$70f00000,$71f8c000
	dc.l	$7fff8000,$7fff8000,$3e1f0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|7]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$30000
	dc.l	$60000,$7cc0000,$1ff80000,$3c780000
	dc.l	$38380000,$787c0000,$78fc0000,$79bc0000
	dc.l	$7b3c0000,$7e3c0000,$7c3c0000,$38380000
	dc.l	$3c780000,$3ff00000,$6fe00000,$c0000000
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|8]
	dc.l	$0,$0,$0,$0
	dc.l	$3c00000,$6600000,$6600000,$6600000
	dc.l	$3c00000,$fe00000,$3ff00000,$30780000
	dc.l	$20780000,$780000,$1f80000,$1ff80000
	dc.l	$3c780000,$78780000,$78780000,$78780000
	dc.l	$78f80000,$3ff80000,$f780000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|9]
	dc.l	$0,$0,$fc0000,$7038000
	dc.l	$8004000,$8784000,$10842000,$11002000
	dc.l	$11002000,$11002000,$10842000,$8784000
	dc.l	$8004000,$7038000,$fc0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|10]
	dc.l	$0,$0,$fc0000,$7038000
	dc.l	$8004000,$8f84000,$10842000,$10842000
	dc.l	$10f82000,$10882000,$10842000,$8844000
	dc.l	$8004000,$7038000,$fc0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|11]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|12]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|13]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|14]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|15]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|16]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|17]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|18]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [3|19]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|0]
	dc.l	$0,$0,$1800000,$3800000
	dc.l	$3f800000,$3f800000,$7800000,$7800000
	dc.l	$7800000,$7800000,$7800000,$7800000
	dc.l	$7800000,$7800000,$7800000,$7800000
	dc.l	$7800000,$7800000,$7800000,$7800000
	dc.l	$7800000,$1ff80000,$1ff80000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|1]
	dc.l	$0,$0,$f800000,$1fe00000
	dc.l	$3ff00000,$70f00000,$20f80000,$20780000
	dc.l	$780000,$780000,$f80000,$f00000
	dc.l	$f00000,$1e00000,$3c00000,$3800000
	dc.l	$7000000,$e000000,$c000000,$1c000000
	dc.l	$3ff80000,$3ff80000,$3ff80000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|2]
	dc.l	$0,$0,$7c00000,$fe00000
	dc.l	$1ff00000,$38f80000,$10f80000,$f80000
	dc.l	$f80000,$f00000,$f00000,$7e00000
	dc.l	$7e00000,$f80000,$780000,$7c0000
	dc.l	$7c0000,$7c0000,$407c0000,$70780000
	dc.l	$7ff80000,$3ff00000,$fc00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|3]
	dc.l	$0,$0,$1f00000,$1f00000
	dc.l	$3f00000,$2f00000,$6f00000,$6f00000
	dc.l	$ef00000,$cf00000,$cf00000,$1cf00000
	dc.l	$1cf00000,$38f00000,$38f00000,$70f00000
	dc.l	$7ffc0000,$7ffc0000,$7ffc0000,$f00000
	dc.l	$f00000,$f00000,$f00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|4]
	dc.l	$0,$0,$3ff00000,$3ff00000
	dc.l	$3ff00000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3fc00000,$3fe00000
	dc.l	$3cf00000,$38f80000,$f80000,$f80000
	dc.l	$f80000,$20f80000,$20f80000,$70f00000
	dc.l	$3ff00000,$1fe00000,$f800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|5]
	dc.l	$0,$0,$3c00000,$fe00000
	dc.l	$1fe00000,$1e200000,$3c000000,$3c000000
	dc.l	$78000000,$78000000,$7bf00000,$7ff80000
	dc.l	$7c380000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$383c0000,$3c780000
	dc.l	$1ff80000,$ff00000,$7c00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|6]
	dc.l	$0,$0,$7ffc0000,$7ffc0000
	dc.l	$7ffc0000,$380000,$780000,$f00000
	dc.l	$f00000,$1f00000,$3e00000,$3e00000
	dc.l	$3c00000,$7c00000,$7c00000,$7c00000
	dc.l	$fc00000,$f800000,$f800000,$f800000
	dc.l	$f800000,$f800000,$f800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|7]
	dc.l	$0,$0,$7c00000,$1ff00000
	dc.l	$1ff00000,$3c780000,$3c780000,$3c780000
	dc.l	$3c780000,$3c780000,$1ef00000,$7c00000
	dc.l	$1ff00000,$38380000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$7c7c0000
	dc.l	$3ff80000,$1ff00000,$fe00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|8]
	dc.l	$0,$0,$7c00000,$1fe00000
	dc.l	$3ff00000,$3c780000,$78380000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$783c0000
	dc.l	$387c0000,$3ffc0000,$1fbc0000,$3c0000
	dc.l	$3c0000,$380000,$780000,$10f00000
	dc.l	$1ff00000,$3fe00000,$1f800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|9]
	dc.l	$0,$0,$7c00000,$1ff00000
	dc.l	$3c780000,$3c780000,$38380000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$783c0000,$783c0000
	dc.l	$783c0000,$783c0000,$38380000,$3c780000
	dc.l	$3c780000,$1ff00000,$7c00000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|10]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$0,$0,$0
	dc.l	$0,$0,$0,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|11]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$0,$0,$0
	dc.l	$0,$0,$0,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$18000000
	dc.l	$30000000,$70000000,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|12]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|13]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|14]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|15]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|16]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|17]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|18]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [4|19]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|0]
	dc.l	$0,$0,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$c000000
	dc.l	$0,$0,$0,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|1]
	dc.l	$0,$0,$7f0000,$3ff8000
	dc.l	$7c3c000,$f01e000,$1e1fe000,$1e7ff000
	dc.l	$1cf1f000,$3ce0f000,$3de0f000,$3de0f000
	dc.l	$3de0f000,$3de0f000,$3de0f000,$3ce0e000
	dc.l	$1cf1e000,$1e7fc000,$1e1f0000,$f000000
	dc.l	$7c0f000,$3ffe000,$7f0000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|2]
	dc.l	$0,$0,$1c3800,$1c3800
	dc.l	$1c3800,$3c7800,$387000,$387000
	dc.l	$387000,$78f000,$1ffffe00,$3fffff00
	dc.l	$3fffff00,$e1c000,$e1c000,$e1c000
	dc.l	$e1c000,$e1c000,$3fffff00,$3fffff00
	dc.l	$1ffffe00,$3c78000,$3870000,$3870000
	dc.l	$3870000,$78f0000,$70e0000,$70e0000
	dc.l	$70e0000,$0,$0
	dc.l	0
*** [5|3]
	dc.l	$0,$1800000,$7c00000,$ff00000
	dc.l	$1ff80000,$3db80000,$3d880000,$3d800000
	dc.l	$3d800000,$3f800000,$3fc00000,$1fe00000
	dc.l	$ff00000,$7f00000,$1f80000,$1f80000
	dc.l	$1f80000,$1f80000,$41f80000,$79f80000
	dc.l	$7ff00000,$3fe00000,$fc00000,$1800000
	dc.l	$1800000,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|4]
	dc.l	$0,$7800000,$1fe00300,$1fe00700
	dc.l	$3cf00f00,$3cf01e00,$3cf03c00,$3cf07c00
	dc.l	$3cf0f800,$3cf0f000,$3cf1e000,$1fe3e000
	dc.l	$1fe3c000,$7878780,$f8fc0,$1f3ce0
	dc.l	$1e3cf0,$3c3cf0,$7c3cf0,$783cf0
	dc.l	$f03cf0,$1f03cf0,$3e03cf0,$3c01ce0
	dc.l	$3800fc0,$1800780,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|5]
	dc.l	$0,$0,$3800000,$7c00000
	dc.l	$6c00000,$c600000,$18300000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|6]
	dc.l	$0,$0,$f80000,$1fe0000
	dc.l	$3df0000,$78f0000,$78f0000,$78f0000
	dc.l	$79e0000,$7bc2000,$7f82000,$7f06000
	dc.l	$3c06000,$7e06000,$ff0e000,$1df1e000
	dc.l	$38f9c000,$787f8000,$783f8000,$7c3f0000
	dc.l	$7fffe000,$3fffe000,$fe0e000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|7]
	dc.l	$0,$3800000,$3800000,$3800000
	dc.l	$33980000,$793c0000,$3ff80000,$7c00000
	dc.l	$7c00000,$3ff80000,$793c0000,$33980000
	dc.l	$3800000,$3800000,$3800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|8]
	dc.l	$0,$c00000,$1800000,$3800000
	dc.l	$7000000,$7000000,$e000000,$e000000
	dc.l	$1e000000,$1c000000,$1c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$1c000000,$1c000000,$1e000000,$e000000
	dc.l	$e000000,$7000000,$7000000,$3800000
	dc.l	$1800000,$c00000,$0
	dc.l	0
*** [5|9]
	dc.l	$0,$30000000,$18000000,$1c000000
	dc.l	$e000000,$e000000,$7000000,$7000000
	dc.l	$7800000,$3800000,$3800000,$3c00000
	dc.l	$3c00000,$3c00000,$3c00000,$3c00000
	dc.l	$3c00000,$3c00000,$3c00000,$3c00000
	dc.l	$3800000,$3800000,$7800000,$7000000
	dc.l	$7000000,$e000000,$e000000,$1c000000
	dc.l	$18000000,$30000000,$0
	dc.l	0
*** [5|10]
	dc.l	$0,$7e000000,$7e000000,$7e000000
	dc.l	$7e000000,$3c000000,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|11]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$1c0000,$1c0000,$1c0000
	dc.l	$1c0000,$1c0000,$1c0000,$1c0000
	dc.l	$1c0000,$1c0000,$3ffffe00,$3ffffe00
	dc.l	$3ffffe00,$1c0000,$1c0000,$1c0000
	dc.l	$1c0000,$1c0000,$1c0000,$1c0000
	dc.l	$1c0000,$1c0000,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|12]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$ff000000
	dc.l	$ff000000,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|13]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$1fffe000,$3fffe000
	dc.l	$3fffe000,$0,$0,$0
	dc.l	$0,$0,$3fffe000,$3fffe000
	dc.l	$1fffe000,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|14]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$ffffe000,$ffffe000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|15]
	dc.l	$0,$3f800000,$3f800000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$3c000000
	dc.l	$3f800000,$3f800000,$0
	dc.l	0
*** [5|16]
	dc.l	$0,$fe000000,$fe000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$1e000000,$1e000000,$1e000000,$1e000000
	dc.l	$fe000000,$fe000000,$0
	dc.l	0
*** [5|17]
	dc.l	$0,$0,$fc00000,$3ff00000
	dc.l	$38780000,$10780000,$780000,$780000
	dc.l	$f00000,$1e00000,$1c00000,$3800000
	dc.l	$3800000,$3800000,$3800000,$3000000
	dc.l	$0,$0,$0,$7800000
	dc.l	$7800000,$7800000,$7800000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|18]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$18000000
	dc.l	$30000000,$70000000,$0,$0
	dc.l	$0,$0,$0
	dc.l	0
*** [5|19]
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0,$3c000000
	dc.l	$3c000000,$3c000000,$3c000000,$0
	dc.l	$0,$0,$0,$0
	dc.l	$0,$0,$0
	dc.l	0

*******************************************************
******* end if text font data *************************
*******************************************************

copptr:	dc.l 0,0,0,0

bars:	movem.l	d0-d7/a0-a6,-(sp)
	move.l	copptr(pc),a0	;erase all bars
	moveq.l	#0,d1
	move.w	d1,2+8*0(a0)
	move.w	d1,2+8*1(a0)
	move.w	d1,2+8*2(a0)
	move.w	d1,2+8*3(a0)
	move.w	d1,2+8*4(a0)
	move.w	d1,2+8*5(a0)
	move.w	d1,2+8*6(a0)
	move.w	d1,2+8*7(a0)
	move.w	d1,2+8*8(a0)
	move.w	d1,2+8*9(a0)
	move.w	d1,2+8*10(a0)
	move.w	d1,2+8*11(a0)
	move.w	d1,2+8*12(a0)
	move.w	d1,2+8*13(a0)
	move.w	d1,2+8*14(a0)
	move.w	d1,2+8*15(a0)
	move.w	d1,2+8*16(a0)
	move.w	d1,2+8*17(a0)
	move.w	d1,2+8*18(a0)
	move.w	d1,2+8*19(a0)
	move.w	d1,2+8*20(a0)
	move.w	d1,2+8*21(a0)
	move.w	d1,2+8*22(a0)
	move.w	d1,2+8*23(a0)
	move.w	d1,2+8*24(a0)
	move.w	d1,2+8*25(a0)
	move.w	d1,2+8*26(a0)
	move.w	d1,2+8*27(a0)
	move.w	d1,2+8*28(a0)
	move.w	d1,2+8*29(a0)
	move.w	d1,2+8*30(a0)
	move.w	d1,2+8*31(a0)
	move.w	d1,2+8*32(a0)
	move.w	d1,2+8*33(a0)
	move.w	d1,2+8*34(a0)
	move.w	d1,2+8*35(a0)
	move.w	d1,2+8*36(a0)
	move.w	d1,2+8*37(a0)
	move.w	d1,2+8*38(a0)
	move.w	d1,2+8*39(a0)
	move.w	d1,2+8*40(a0)
	move.w	d1,2+8*41(a0)
	move.w	d1,2+8*42(a0)
	move.w	d1,2+8*43(a0)
	move.w	d1,2+8*44(a0)
	move.w	d1,2+8*45(a0)
	move.w	d1,2+8*46(a0)
	move.w	d1,2+8*47(a0)
	move.w	d1,2+8*48(a0)
	move.w	d1,2+8*49(a0)
	move.w	d1,2+8*50(a0)
	move.w	d1,2+8*51(a0)
	move.w	d1,2+8*52(a0)
	move.w	d1,2+8*53(a0)
	move.w	d1,2+8*54(a0)
	move.w	d1,2+8*55(a0)
	move.w	d1,2+8*56(a0)
	move.w	d1,2+8*57(a0)
	move.w	d1,2+8*58(a0)
	move.w	d1,2+8*59(a0)
	move.w	d1,2+8*60(a0)
	move.w	d1,2+8*61(a0)
	move.w	d1,2+8*62(a0)
	move.w	d1,2+8*63(a0)
	move.w	d1,2+8*64(a0)
	move.w	d1,2+8*65(a0)
	move.w	d1,2+8*66(a0)
	move.w	d1,2+8*67(a0)
	move.w	d1,2+8*68(a0)
	move.w	d1,2+8*69(a0)
	move.w	d1,2+8*70(a0)
	move.w	d1,2+8*71(a0)
	move.w	d1,2+8*72(a0)
	move.w	d1,2+8*73(a0)
	move.w	d1,2+8*74(a0)
	move.w	d1,2+8*75(a0)
	move.w	d1,2+8*76(a0)
	move.w	d1,2+8*77(a0)
	move.w	d1,2+8*78(a0)
	move.w	d1,2+8*79(a0)
	move.w	d1,2+8*80(a0)
	move.w	d1,2+8*81(a0)
	move.w	d1,2+8*82(a0)
	move.w	d1,2+8*83(a0)
	move.w	d1,2+8*84(a0)
	move.w	d1,2+8*85(a0)
	move.w	d1,2+8*86(a0)
	move.w	d1,2+8*87(a0)
	move.w	d1,2+8*88(a0)
	move.w	d1,2+8*89(a0)
	move.w	d1,2+8*90(a0)
	move.w	d1,2+8*91(a0)
	move.w	d1,2+8*92(a0)
	move.w	d1,2+8*93(a0)
	move.w	d1,2+8*94(a0)
	move.w	d1,2+8*95(a0)
	move.w	d1,2+8*96(a0)
	move.w	d1,2+8*97(a0)
	move.w	d1,2+8*98(a0)
	move.w	d1,2+8*99(a0)
	move.w	d1,2+8*100(a0)
	move.w	d1,2+8*101(a0)
	move.w	d1,2+8*102(a0)
	move.w	d1,2+8*103(a0)
	move.w	d1,2+8*104(a0)
	move.w	d1,2+8*105(a0)
	move.w	d1,2+8*106(a0)
	move.w	d1,2+8*107(a0)
	move.w	d1,2+8*108(a0)
	move.w	d1,2+8*109(a0)
	move.w	d1,2+8*110(a0)
	move.w	d1,2+8*111(a0)
	move.w	d1,2+8*112(a0)
	move.w	d1,2+8*113(a0)
	move.w	d1,2+8*114(a0)
	move.w	d1,2+8*115(a0)
	move.w	d1,2+8*116(a0)
	move.w	d1,2+8*117(a0)
	move.w	d1,2+8*118(a0)
	move.w	d1,2+8*119(a0)
	move.w	d1,2+8*120(a0)
	move.w	d1,2+8*121(a0)
	move.w	d1,2+8*122(a0)
	move.w	d1,2+8*123(a0)
	move.w	d1,2+8*124(a0)
	move.w	d1,2+8*125(a0)
	move.w	d1,2+8*126(a0)
	move.w	d1,2+8*127(a0)
	move.w	d1,2+8*128(a0)
	move.w	d1,2+8*129(a0)
	move.w	d1,2+8*130(a0)
	move.w	d1,2+8*131(a0)
	move.w	d1,2+8*132(a0)
	move.w	d1,2+8*133(a0)
	move.w	d1,2+8*134(a0)
	move.w	d1,2+8*135(a0)
	move.w	d1,2+8*136(a0)
	move.w	d1,2+8*137(a0)
	move.w	d1,2+8*138(a0)
	move.w	d1,2+8*139(a0)
	move.w	d1,2+8*140(a0)
	move.w	d1,2+8*141(a0)
	move.w	d1,2+8*142(a0)
	move.w	d1,2+8*143(a0)
	move.w	d1,2+8*144(a0)
	move.w	d1,2+8*145(a0)
	move.w	d1,2+8*146(a0)
	move.w	d1,2+8*147(a0)
	move.w	d1,2+8*148(a0)
	move.w	d1,2+8*149(a0)
	move.w	d1,2+8*150(a0)
	move.w	d1,2+8*151(a0)
	move.w	d1,2+8*152(a0)
	move.w	d1,2+8*153(a0)
	move.w	d1,2+8*154(a0)
	move.w	d1,2+8*155(a0)
	move.w	d1,2+8*156(a0)
	move.w	d1,2+8*157(a0)
	move.w	d1,2+8*158(a0)
	move.w	d1,2+8*159(a0)
	move.w	d1,2+8*160(a0)
	move.w	d1,2+8*161(a0)
	move.w	d1,2+8*162(a0)
	move.w	d1,2+8*163(a0)
	move.w	d1,2+8*164(a0)
	move.w	d1,2+8*165(a0)
	move.w	d1,2+8*166(a0)
	move.w	d1,2+8*167(a0)
	move.w	d1,2+8*168(a0)
	move.w	d1,2+8*169(a0)
	move.w	d1,2+8*170(a0)
	move.w	d1,2+8*171(a0)
	move.w	d1,2+8*172(a0)
	move.w	d1,2+8*173(a0)
	move.w	d1,2+8*174(a0)
	move.w	d1,2+8*175(a0)
	move.w	d1,2+8*176(a0)
	move.w	d1,2+8*177(a0)
	move.w	d1,2+8*178(a0)
	move.w	d1,2+8*179(a0)
	move.w	d1,2+8*180(a0)
	move.w	d1,2+8*181(a0)
	move.w	d1,2+8*182(a0)
	move.w	d1,2+8*183(a0)
	move.w	d1,2+8*184(a0)
	move.w	d1,2+8*185(a0)
	move.w	d1,2+8*186(a0)
	move.w	d1,2+8*187(a0)
	move.w	d1,2+8*188(a0)
	move.w	d1,2+8*189(a0)
	move.w	d1,2+8*190(a0)
	move.w	d1,2+8*191(a0)
	move.w	d1,2+8*192(a0)
	move.w	d1,2+8*193(a0)
	move.w	d1,2+8*194(a0)
	move.w	d1,2+8*195(a0)
	move.w	d1,2+8*196(a0)
	move.w	d1,2+8*197(a0)
	move.w	d1,2+8*198(a0)
	move.w	d1,2+8*199(a0)
	move.w	d1,2+8*200(a0)
	move.w	d1,2+8*201(a0)
	move.w	d1,2+8*202(a0)
	move.w	d1,2+8*203(a0)
	move.w	d1,2+8*204(a0)
	move.w	d1,2+8*205(a0)
	move.w	d1,2+8*206(a0)
	move.w	d1,2+8*207(a0)
	move.w	d1,2+8*208(a0)
	move.w	d1,2+8*209(a0)

	lea.l	intable(pc),a5
	lea.l	thycols(pc),a4
	lea.l	sine(pc),a3
	moveq	#0,d0				; First bar

2$:	move.l	copptr(pc),a2
	move.w	(a5)+,d7
	addq.b	#1,-1(a5)
	move.b	(a3,d7.w),d1			; Y Position
	and.w	#$ff,d1
	asl.w	#3,d1				;*8(each coplist entry=8bytes)
	move.w	d0,d6
	asl.w	#5,d6				; *16 each colorlist e = 16
	moveq.l	#15,d5
3$:	move.w	(a4,d6.w),2(a2,d1.w)
	addq.l	#8,a2
	addq.l	#2,d6
	dbf	d5,3$
	addq.l	#1,d0
	cmpi.b	#8,d0
	bne.s	2$
	lea.l	intable(pc),a5
	lea.l	thycols(pc),a4
	lea.l	sine(pc),a3
	moveq	#0,d0				; First bar
4$:	move.l	copptr(pc),a2
	move.w	(a5)+,d7
	addq.l	#1,d0
	cmpi.b	#8,d0
	bne.s	4$
0$:	movem.l	(sp)+,d0-d7/a0-a6
	rts


intable:
	dc.w 0,8,16,24,32,40,48,56
	dc.w 0,15,30,45,60,75,90,105
thycols:
	dc.w $0111,$0333,$0555,$0777,$0999,$0bbb,$0ddd,$0fff
	dc.w $0fff,$0ddd,$0bbb,$0999,$0777,$0555,$0333,$0111
	dc.w $0101,$0303,$0505,$0707,$0909,$0b0b,$0d0d,$0f0f
	dc.w $0f0f,$0d0d,$0b0b,$0909,$0707,$0505,$0303,$0101
	dc.w $0011,$0033,$0055,$0077,$0099,$00bb,$00dd,$00ff
	dc.w $00ff,$00dd,$00bb,$0099,$0077,$0055,$0033,$0011
	dc.w $0101,$0330,$0550,$0770,$0990,$0bb0,$0dd0,$0ff0
	dc.w $0ff0,$0dd0,$0bb0,$0990,$0770,$0550,$0330,$0110
	dc.w $0100,$0300,$0500,$0700,$0900,$0b00,$0d00,$0f00
	dc.w $0f00,$0d00,$0b00,$0900,$0700,$0500,$0300,$0100
	dc.w $0001,$0003,$0005,$0007,$0009,$000b,$000d,$000f
	dc.w $000f,$000d,$000b,$0009,$0007,$0005,$0003,$0001
	dc.w $0010,$0030,$0050,$0070,$0090,$00b0,$00d0,$00f0
	dc.w $00f0,$00d0,$00b0,$0090,$0070,$0050,$0030,$0010
	dc.w $0101,$0303,$0505,$0707,$0909,$0b0b,$0d0d,$0f0f
	dc.w $0f0f,$0d0d,$0b0b,$0909,$0707,$0505,$0303,$0101

sine:
	dc.b 95,97,99,101,104,106,108,111,113,115,118,120,122,124,127
	dc.b 129,131,133,135,137,139,141,143,145,147,149,151,153,155,157
	dc.b 158,160,162,163,165,166,168,169,171,172,173,175,176,177,178
	dc.b 179,180,181,182,183,184,185,185,186,187,187,188,188,188,189
	dc.b 189,189,189,189,190,189,189,189,189,189,188,188,188,187,187
	dc.b 186,185,185,184,183,182,181,180,179,178,177,176,175,173,172
	dc.b 171,169,168,166,165,163,162,160,158,157,155,153,151,149,147
	dc.b 145,143,141,139,137,135,133,131,129,127,124,122,120,118,115
	dc.b 113,111,108,106,104,101,99,97,94,92,90,88,85,83,81
	dc.b 78,76,74,71,69,67,65,62,60,58,56,54,52,50,48
	dc.b 46,44,42,40,38,36,34,32,31,29,27,26,24,23,21
	dc.b 20,18,17,16,14,13,12,11,10,9,8,7,6,5,4
	dc.b 4,3,2,2,1,1,1,0,0,0,0,0,0,0,0
	dc.b 0,0,0,1,1,1,2,2,3,4,4,5,6,7,8
	dc.b 9,10,11,12,13,14,16,17,18,20,21,23,24,26,27
	dc.b 29,31,32,34,36,38,40,42,44,46,48,50,52,54,56
	dc.b 58,60,62,65,67,69,71,74,76,78,81,83,85,88,90
	dc.b 92,95

	even




************system return*****************

system_push:	movea.l	($4).l,a6
		lea.l	GfxName(pc),a1
		clr.l	d0
		jsr	-$228(a6)	* OpenLibrary
		move.l	d0,a1
		move.l	38(a1),d7	* Find current copperlist
		jsr	-$19e(a6)	* CloseLibrary
		lea.l	copy_register(pc),a0
		move.l	d7,4(a0)	* save copperlist
                move.w	($dff002).l,0(a0)	* save dma
		or.w	#$8000,0(a0)
                move.w	($dff01c).l,2(a0)	* save interrupt
		or.w	#$8000,2(a0)
                move.w	#$7fff,($dff09a).l	* no interrupt
		move.w	#$07ff,($dff096).l	* no dma
		bsr	backup_vektor
                rts

system_pop:	move.w	#$7fff,($dff09a).l	* no interrupt
		move.w	#$07ff,($dff096).l	* no dma
		bsr	restore_vektor
		lea.l	copy_register(pc),a0
		move.l	4(a0),($dff080).l	* restore system copper list
		clr.w	($dff088).l
		move.w	0(a0),($dff096).l	* restore dma
                move.w	2(a0),($dff09a).l	* restore interrupt
                rts

copy_register:	dc.w	0,0
		dc.l	0

GfxName:	dc.b	"graphics.library",0
		even

backup_vektor:	movem.l	d0/a0-a1,-(sp)
		move.l  #254,d0
		move.l  #$000000,a0
		lea.l	copy_vektor(pc),a1
1$:		move.l	(a0)+,(a1)+
		dbra	d0,1$
		movem.l	(sp)+,d0/a0-a1
		rts

restore_vektor:	movem.l	d0/a0-a1,-(sp)
		move.l  #254,d0
		move.l  #$000000,a0
		lea.l	copy_vektor(pc),a1
1$:		move.l	(a1)+,(a0)+
		dbra	d0,1$
		movem.l	(sp)+,d0/a0-a1
		rts

copy_vektor:	ds.l	256

******************************************



